#!/usr/bin/env python3
# encoding: utf-8
# api: pip
# type: build
# title: config for setuptools
#
# Always prefer setuptools over distutils
#

from pluginconf.setup import setup

setup(
    #debug=1,
    fn="cookiedough/__init__.py",
    name="cookiedough",
    long_description="README.md",
    packages=["cookiedough"],
    package_dir={"": "."},
    package_data={
        "cookiedough": [
            "./*.json",
            "./*.patch",
            "./help/*.*",
        ],
    },
    include_package_data=True,
    entry_points={
        "console_scripts": [
            "cookiedough=cookiedough:main",
        ]
    },
    extras_require={
        "build": ["pluginconf","setuptools"],
        "unused": ["ttkthemes"]
    },
    universal=False
)
